require("lxp")

local OpenTags
local Result
local NumOpenTags
local callback,callbacklevel

local function StartElement (parser, name, attrs)
	local p,t
	if (NumOpenTags==0) then
		p=Result
		else 
			p=OpenTags[NumOpenTags].Tag
		end
	p.Children=p.Children or {}
	p.Children[name] = p.Children[name] or {}
	table.insert(p.Children[name],{Attrs=attrs})
	t=p.Children[name][table.getn(p.Children[name])]
	t.Children={}
	NumOpenTags=NumOpenTags+1
	OpenTags[NumOpenTags]={Name=name,Parent=p,Tag=t}
end

local function EndElement (parser, name)
	NumOpenTags=NumOpenTags-1
	if (NumOpenTags==callbacklevel)and(callback) then
		if OpenTags[NumOpenTags].Tag.Children then
			local n=table.getn(OpenTags[NumOpenTags].Tag.Children[name])
			local t=OpenTags[NumOpenTags].Tag.Children[name][n]
			local e,msg=pcall(callback,name,t)
			if not e then
				print(string.format("Error calling callback in xml_to_table: %s",msg))
				end
			OpenTags[NumOpenTags].Tag.Children[name][n]=nil
			end
		end
end

local function CharacterData (parser, str)
	OpenTags[NumOpenTags].Tag.Data= (OpenTags[NumOpenTags].Tag.Data or "")..str
end

local callbacks = {
	StartElement = StartElement,
	EndElement = EndElement,
	CharacterData = CharacterData
	}

local function Init(level,Callback)
	callback=Callback
	callbacklevel=level
	OpenTags={}
	NumOpenTags=0
	Result={}
end

XmlToTable={

	ParseFile=function(file,level,Callback)
		Init(level,Callback)
		local lx = lxp.new(callbacks)
		local l
		for l in file:lines() do
			lx:parse(l)
			lx:parse("\n")
			end
		lx:parse()
		lx:close()
		return Result
	end,

	ParseString=function(str,level,Callback)
		Init(level,Callback)
		local lx = lxp.new(callbacks)
		local l
		lx:parse(str)
		lx:parse()
		lx:close()
		return Result
	end,
	
	GetChild=function(tag,...)
		local i
		for i=1,arg.n do
			if (tag.Children[arg[i]])and(tag.Children[arg[i]][1]) then
				tag=tag.Children[arg[i]][1]
				else return nil
				end
			end
	return tag
	end,

	}